Subject: bug#52751: 27.1; Go back to editing the from part in query replace

From: Daniel Martín <[email-masked]>
Date: Sun, 26 Dec 2021 01:08:36 +0100

ndame <[email-masked]> writes:

> I often run into the situation of doing a complicated query
> replace/regexp, submitting the FROM part and then during editing the
> TO part I notice an error in FROM. But I cannot go back there to fix
> it, I can either cancel the replace which deletes the FROM part,
> because it did not yet go into history [...]

The FROM value is stored in history even if you abort the query and
replace without completing it:

emacs -Q
M-% foo RET
C-g
M-% M-p (this should recover "foo").

There's room for improvement, though.  If there are complete query
replace items of the form FROM -> TO, then they are placed before the
FROM entries in the history.  Perhaps there should be a mechanism to
recover those FROM entries from history more quickly.